= nng_msg_alloc(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_msg_alloc - allocate a message

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

int nng_msg_alloc(nng_msg **msgp, size_t size);
----

== DESCRIPTION

The `nng_msg_alloc()` function allocates a new message with body length _size_
and stores the result in __msgp__.
Messages allocated with this function contain a body and optionally a header.
They are used with receive and transmit functions.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists to allocate a message.

== SEE ALSO

[.text-left]
xref:nng_msg_free.3.adoc[nng_msg_free(3)],
xref:nng_msg_body.3.adoc[nng_msg_body(3)],
xref:nng_msg_dup.3.adoc[nng_msg_dup(3)],
xref:nng_msg_header.3.adoc[nng_msg_header(3)],
xref:nng_msg_header_len.3.adoc[nng_msg_header_len(3)],
xref:nng_msg_len.3.adoc[nng_msg_len(3)],
xref:nng_msg_capacity.3.adoc[nng_msg_capacity(3)],
xref:nng_msg_reserve.3.adoc[nng_msg_reserve(3)],
xref:nng_msg_realloc.3.adoc[nng_msg_realloc(3)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng_msg.5.adoc[nng_msg(5)],
xref:nng.7.adoc[nng(7)]
